require 'workarea'
require 'workarea/storefront'
require 'workarea/admin'

require 'workarea/facebook_conversion_tracking/engine'
require 'workarea/facebook_conversion_tracking/version'

require 'workarea/facebook_conversion_tracking/models/events/base'
require 'workarea/facebook_conversion_tracking/models/events/add_to_cart'
require 'workarea/facebook_conversion_tracking/models/events/purchase'
require 'workarea/facebook_conversion_tracking/gateway'

module Workarea
  module FacebookConversionTracking
    # used for <= 3.5, these creds come from secrets isntead of encrypted in the
    # 3.5 configurations system.
    def self.credentials
      (Rails.application.secrets.facebook_conversion_tracking || {}).deep_symbolize_keys
    end

    def self.pixel_id
      Workarea.config.facebook_conversion_tracking_pixel_id || credentials[:pixel_id]
    end

    def self.access_token
      Workarea.config.facebook_conversion_tracking_access_token || credentials[:access_token]
    end

    def self.test_code
      Workarea.config.facebook_conversion_tracking_test_code || credentials[:test_code]
    end

    def self.configured?
      pixel_id.present? && access_token.present?
    end
  end
end
