module Workarea
  module FacebookConversionTracking
    module Models
      module Events
        class AddToCart < Base
          def perform
            event = build_event

            custom_data = {
              content_type: @params[:content_type],
              content_ids: products.pluck(:id),
              name: products.pluck(:name),
              sku: products.pluck(:sku),
              sale: products.pluck(:sale),
              price: products.pluck(:price)
            }

            event[:custom_data] = custom_data

            send([event])
          end
        end
      end
    end
  end
end
