module Workarea
  module FacebookConversionTracking
    module Models
      module Events
        class Base
          def initialize(request, params)
            @request = request
            @params = params
          end

          def products
            @params[:products].values
          end

          def build_event
            {
              event_name: @params[:event],
              event_id: @params[:event_id],
              event_time: Time.current.to_i,
              event_source_url: @params[:event_source_url],
              action_source: 'website',
              user_data: {
                client_ip_address: @request.remote_ip,
                client_user_agent: @request.user_agent
              },
              custom_data: {}
            }
          end

          def send(event)
            Workarea::FacebookConversionTrackingGateway.new(event).send
          end
        end
      end
    end
  end
end
