module Workarea
  module FacebookConversionTracking
    module Models
      module Events
        class Purchase < Base
          def perform
            event = build_event

            custom_data = {
              id: @params[:id],
              promo_codes: @params[:promo_codes],
              shipping_service: @params[:shipping_service],
              shipping_total: @params[:shipping_total],
              tax_total: @params[:tax_total],
              tenders: @params[:tenders],
              value: @params[:value], #required
              currency: @params[:currency], #required
              content_type: @params[:content_type], #required for Dynamic Ads
              content_ids: products.pluck(:id), #required for Dynamic Ads
              name: products.pluck(:name),
              sku: products.pluck(:sku),
              price: products.pluck(:price),
              quantity: products.pluck(:quantity),
              category: products.pluck(:category)
            }
            event[:custom_data] = custom_data

            send([event])
          end
        end
      end
    end
  end
end
